ClassNode (ASM 5.0.4 Documentation)
Date: 2015-09-18

org.objectweb.asm.tree

## Class ClassNode

- java.lang.Object
- - org.objectweb.asm.ClassVisitor
  - - org.objectweb.asm.tree.ClassNode

-     public class ClassNode
      extends ClassVisitor

  A node that represents a class.
  Author:
    Eric Bruneton

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `int` | `access` The class's access flags (see `Opcodes`).
    `List<Attribute>` | `attrs` The non standard attributes of this class.
    `List<FieldNode>` | `fields` The fields of this class.
    `List<InnerClassNode>` | `innerClasses` Informations about the inner classes of this class.
    `List<String>` | `interfaces` The internal names of the class's interfaces (see `getInternalName`).
    `List<AnnotationNode>` | `invisibleAnnotations` The runtime invisible annotations of this class.
    `List<TypeAnnotationNode>` | `invisibleTypeAnnotations` The runtime invisible type annotations of this class.
    `List<MethodNode>` | `methods` The methods of this class.
    `String` | `name` The internal name of the class (see `getInternalName`).
    `String` | `outerClass` The internal name of the enclosing class of the class.
    `String` | `outerMethod` The name of the method that contains the class, or `null` if the class is not enclosed in a method.
    `String` | `outerMethodDesc` The descriptor of the method that contains the class, or `null` if the class is not enclosed in a method.
    `String` | `signature` The signature of the class.
    `String` | `sourceDebug` Debug information to compute the correspondence between source and compiled elements of the class.
    `String` | `sourceFile` The name of the source file from which this class was compiled.
    `String` | `superName` The internal of name of the super class (see `getInternalName`).
    `int` | `version` The class version.
    `List<AnnotationNode>` | `visibleAnnotations` The runtime visible annotations of this class.
    `List<TypeAnnotationNode>` | `visibleTypeAnnotations` The runtime visible type annotations of this class.

    - ### Fields inherited from class org.objectweb.asm.ClassVisitor

      `api, cv`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ClassNode()` Constructs a new `ClassNode`.
    `ClassNode(int api)` Constructs a new `ClassNode`.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `accept(ClassVisitor cv)` Makes the given class visitor visit this class.
    `void` | `check(int api)` Checks that this class node is compatible with the given ASM API version.
    `void` | `visit(int version, int access, String name, String signature, String superName, String[] interfaces)` Visits the header of the class.
    `AnnotationVisitor` | `visitAnnotation(String desc, boolean visible)` Visits an annotation of the class.
    `void` | `visitAttribute(Attribute attr)` Visits a non standard attribute of the class.
    `void` | `visitEnd()` Visits the end of the class.
    `FieldVisitor` | `visitField(int access, String name, String desc, String signature, Object value)` Visits a field of the class.
    `void` | `visitInnerClass(String name, String outerName, String innerName, int access)` Visits information about an inner class.
    `MethodVisitor` | `visitMethod(int access, String name, String desc, String signature, String[] exceptions)` Visits a method of the class.
    `void` | `visitOuterClass(String owner, String name, String desc)` Visits the enclosing class of the class.
    `void` | `visitSource(String file, String debug)` Visits the source of the class.
    `AnnotationVisitor` | `visitTypeAnnotation(int typeRef, TypePath typePath, String desc, boolean visible)` Visits an annotation on a type in the class signature.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### version

          public int version

      The class version.

    - #### access

          public int access

      The class's access flags (see `Opcodes`). This field also indicates if the class is deprecated.

    - #### name

          public String name

      The internal name of the class (see `getInternalName`).

    - #### signature

          public String signature

      The signature of the class. May be `null`.

    - #### superName

          public String superName

      The internal of name of the super class (see `getInternalName`). For interfaces, the super class is `Object`. May be `null`, but only for the `Object` class.

    - #### interfaces

          public List<String> interfaces

      The internal names of the class's interfaces (see `getInternalName`). This list is a list of `String` objects.

    - #### sourceFile

          public String sourceFile

      The name of the source file from which this class was compiled. May be `null`.

    - #### sourceDebug

          public String sourceDebug

      Debug information to compute the correspondence between source and compiled elements of the class. May be `null`.

    - #### outerClass

          public String outerClass

      The internal name of the enclosing class of the class. May be `null`.

    - #### outerMethod

          public String outerMethod

      The name of the method that contains the class, or `null` if the class is not enclosed in a method.

    - #### outerMethodDesc

          public String outerMethodDesc

      The descriptor of the method that contains the class, or `null` if the class is not enclosed in a method.

    - #### visibleAnnotations

          public List<AnnotationNode> visibleAnnotations

      The runtime visible annotations of this class. This list is a list of `AnnotationNode` objects. May be `null`.

    - #### invisibleAnnotations

          public List<AnnotationNode> invisibleAnnotations

      The runtime invisible annotations of this class. This list is a list of `AnnotationNode` objects. May be `null`.

    - #### visibleTypeAnnotations

          public List<TypeAnnotationNode> visibleTypeAnnotations

      The runtime visible type annotations of this class. This list is a list of `TypeAnnotationNode` objects. May be `null`.

    - #### invisibleTypeAnnotations

          public List<TypeAnnotationNode> invisibleTypeAnnotations

      The runtime invisible type annotations of this class. This list is a list of `TypeAnnotationNode` objects. May be `null`.

    - #### attrs

          public List<Attribute> attrs

      The non standard attributes of this class. This list is a list of `Attribute` objects. May be `null`.

    - #### innerClasses

          public List<InnerClassNode> innerClasses

      Informations about the inner classes of this class. This list is a list of `InnerClassNode` objects.

    - #### fields

          public List<FieldNode> fields

      The fields of this class. This list is a list of `FieldNode` objects.

    - #### methods

          public List<MethodNode> methods

      The methods of this class. This list is a list of `MethodNode` objects.

  - ### Constructor Detail

    - #### ClassNode

          public ClassNode()

      Constructs a new `ClassNode`. Subclasses must not use this constructor. Instead, they must use the `ClassNode(int)` version.
      Throws:
        `IllegalStateException` - If a subclass calls this constructor.

    - #### ClassNode

          public ClassNode(int api)

      Constructs a new `ClassNode`.
      Parameters:
        `api` - the ASM API version implemented by this visitor. Must be one of `Opcodes.ASM4` or `Opcodes.ASM5`.

  - ### Method Detail

    - #### visit

          public void visit(int version,
                   int access,
                   String name,
                   String signature,
                   String superName,
                   String[] interfaces)

      Description copied from class: `ClassVisitor`
      Visits the header of the class.
      Overrides:
        `visit` in class `ClassVisitor`
      Parameters:
        `version` - the class version.
        `access` - the class's access flags (see `Opcodes`). This parameter also indicates if the class is deprecated.
        `name` - the internal name of the class (see `getInternalName`).
        `signature` - the signature of this class. May be `null` if the class is not a generic one, and does not extend or implement generic classes or interfaces.
        `superName` - the internal of name of the super class (see `getInternalName`). For interfaces, the super class is `Object`. May be `null`, but only for the `Object` class.
        `interfaces` - the internal names of the class's interfaces (see `getInternalName`). May be `null`.

    - #### visitSource

          public void visitSource(String file,
                         String debug)

      Description copied from class: `ClassVisitor`
      Visits the source of the class.
      Overrides:
        `visitSource` in class `ClassVisitor`
      Parameters:
        `file` - the name of the source file from which the class was compiled. May be `null`.
        `debug` - additional debug information to compute the correspondance between source and compiled elements of the class. May be `null`.

    - #### visitOuterClass

          public void visitOuterClass(String owner,
                             String name,
                             String desc)

      Description copied from class: `ClassVisitor`
      Visits the enclosing class of the class. This method must be called only if the class has an enclosing class.
      Overrides:
        `visitOuterClass` in class `ClassVisitor`
      Parameters:
        `owner` - internal name of the enclosing class of the class.
        `name` - the name of the method that contains the class, or `null` if the class is not enclosed in a method of its enclosing class.
        `desc` - the descriptor of the method that contains the class, or `null` if the class is not enclosed in a method of its enclosing class.

    - #### visitAnnotation

          public AnnotationVisitor visitAnnotation(String desc,
                                          boolean visible)

      Description copied from class: `ClassVisitor`
      Visits an annotation of the class.
      Overrides:
        `visitAnnotation` in class `ClassVisitor`
      Parameters:
        `desc` - the class descriptor of the annotation class.
        `visible` - `true` if the annotation is visible at runtime.
      Returns:
        a visitor to visit the annotation values, or `null` if this visitor is not interested in visiting this annotation.

    - #### visitTypeAnnotation

          public AnnotationVisitor visitTypeAnnotation(int typeRef,
                                              TypePath typePath,
                                              String desc,
                                              boolean visible)

      Description copied from class: `ClassVisitor`
      Visits an annotation on a type in the class signature.
      Overrides:
        `visitTypeAnnotation` in class `ClassVisitor`
      Parameters:
        `typeRef` - a reference to the annotated type. The sort of this type reference must be `CLASS_TYPE_PARAMETER`, `CLASS_TYPE_PARAMETER_BOUND` or `CLASS_EXTENDS`. See `TypeReference`.
        `typePath` - the path to the annotated type argument, wildcard bound, array element type, or static inner type within 'typeRef'. May be `null` if the annotation targets 'typeRef' as a whole.
        `desc` - the class descriptor of the annotation class.
        `visible` - `true` if the annotation is visible at runtime.
      Returns:
        a visitor to visit the annotation values, or `null` if this visitor is not interested in visiting this annotation.

    - #### visitAttribute

          public void visitAttribute(Attribute attr)

      Description copied from class: `ClassVisitor`
      Visits a non standard attribute of the class.
      Overrides:
        `visitAttribute` in class `ClassVisitor`
      Parameters:
        `attr` - an attribute.

    - #### visitInnerClass

          public void visitInnerClass(String name,
                             String outerName,
                             String innerName,
                             int access)

      Description copied from class: `ClassVisitor`
      Visits information about an inner class. This inner class is not necessarily a member of the class being visited.
      Overrides:
        `visitInnerClass` in class `ClassVisitor`
      Parameters:
        `name` - the internal name of an inner class (see `getInternalName`).
        `outerName` - the internal name of the class to which the inner class belongs (see `getInternalName`). May be `null` for not member classes.
        `innerName` - the (simple) name of the inner class inside its enclosing class. May be `null` for anonymous inner classes.
        `access` - the access flags of the inner class as originally declared in the enclosing class.

    - #### visitField

          public FieldVisitor visitField(int access,
                                String name,
                                String desc,
                                String signature,
                                Object value)

      Description copied from class: `ClassVisitor`
      Visits a field of the class.
      Overrides:
        `visitField` in class `ClassVisitor`
      Parameters:
        `access` - the field's access flags (see `Opcodes`). This parameter also indicates if the field is synthetic and/or deprecated.
        `name` - the field's name.
        `desc` - the field's descriptor (see `Type`).
        `signature` - the field's signature. May be `null` if the field's type does not use generic types.
        `value` - the field's initial value. This parameter, which may be `null` if the field does not have an initial value, must be an `Integer`, a `Float`, a `Long`, a `Double` or a `String` (for `int`, `float`, `long` or `String` fields respectively). This parameter is only used for static fields. Its value is ignored for non static fields, which must be initialized through bytecode instructions in constructors or methods.
      Returns:
        a visitor to visit field annotations and attributes, or `null` if this class visitor is not interested in visiting these annotations and attributes.

    - #### visitMethod

          public MethodVisitor visitMethod(int access,
                                  String name,
                                  String desc,
                                  String signature,
                                  String[] exceptions)

      Description copied from class: `ClassVisitor`
      Visits a method of the class. This method must return a new `MethodVisitor` instance (or `null`) each time it is called, i.e., it should not return a previously returned visitor.
      Overrides:
        `visitMethod` in class `ClassVisitor`
      Parameters:
        `access` - the method's access flags (see `Opcodes`). This parameter also indicates if the method is synthetic and/or deprecated.
        `name` - the method's name.
        `desc` - the method's descriptor (see `Type`).
        `signature` - the method's signature. May be `null` if the method parameters, return type and exceptions do not use generic types.
        `exceptions` - the internal names of the method's exception classes (see `getInternalName`). May be `null`.
      Returns:
        an object to visit the byte code of the method, or `null` if this class visitor is not interested in visiting the code of this method.

    - #### visitEnd

          public void visitEnd()

      Description copied from class: `ClassVisitor`
      Visits the end of the class. This method, which is the last one to be called, is used to inform the visitor that all the fields and methods of the class have been visited.
      Overrides:
        `visitEnd` in class `ClassVisitor`

    - #### check

          public void check(int api)

      Checks that this class node is compatible with the given ASM API version. This methods checks that this node, and all its nodes recursively, do not contain elements that were introduced in more recent versions of the ASM API than the given version.
      Parameters:
        `api` - an ASM API version. Must be one of `Opcodes.ASM4` or `Opcodes.ASM5`.

    - #### accept

          public void accept(ClassVisitor cv)

      Makes the given class visitor visit this class.
      Parameters:
        `cv` - a class visitor.